#include <OneWire.h> //Librairie  OneWire
#include <DallasTemperature.h> //Librairie du capteur
 
unsigned long previousMillis = 0;//variable delay sans arrt du programme
 
const long interval = 1000;// variable delay sans arrt du programme qui prevoit une lecture de 1 seconde par mesure
 
OneWire oneWire(2); //PIN digital de la sonde sur la pin 2 de l'arduino
DallasTemperature sensors(&oneWire); //Utilistion du bus Onewire pour les capteurs
DeviceAddress sensorDeviceAddress; //Vrifie la compatibilit des capteurs avec la librairie

// Calcul de la temprature  partir de la relation de Steinhart-Hart
#define Vcc 5 // Tension d'alimentation
#define Ro 10000 // Rsistance du pont
#define C1 0.0009040694038080225
#define C2 0.0002481520267247136
#define C3 2.1768794074726443e-07
float u; // Tension CTN
float R; // Rsistance CTN
float logR; // ln(R)
float T; // Temprature en C



void setup() {
 
  Serial.begin(9600); //dfinition de la vitesse et de l'ouverture du port srie
  sensors.begin(); //Sonde active
  sensors.getAddress(sensorDeviceAddress, 0); //Adresse de la sonde  0
  sensors.setResolution(sensorDeviceAddress, 12); //Rsolutions
 }

void loop() {

  unsigned long currentMillis = millis();// inclure une variable de temps par rapport  millis()

  u = analogRead(A6)*5.0/1023; // Lecture tension en V
  R = Ro * u/(Vcc-u); // Calcul de la rsistance
  logR = log(R); // Calcul de ln(R)
  T = (1.0 / (C1 + C2*logR + C3*logR*logR*logR)); // Calcul de la temprature
  T = T - 273.15; // Conversion en C
  Serial.print("R ctn = "); // Dbut affichage
  Serial.print(R);
  Serial.println(" Ohm");
  Serial.print("T ctn = ");
  Serial.print(T);
  Serial.println(" C");
  Serial.println(" "); // Fin affichage


  if (currentMillis - previousMillis >= interval) {
       previousMillis = currentMillis;
 
    sensors.requestTemperatures(); //Demande la temprature aux capteurs
    Serial.print("T DS18B20 = ");
    Serial.print(sensors.getTempCByIndex(0)); //Information rcupre sur l'adresse 0 de la sonde
    Serial.println(" C");
   }

  delay(10000); 

}